window.babbleBaseUrl = 'https://babble-app-backend.herokuapp.com' //'http://127.0.0.1:8000'

function randomIntFromInterval(min, max) { // min and max included 
	return Math.floor(Math.random() * (max - min + 1) + min)
}

function mobileCheck() {
  let check = false;
  (function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
  return check;
};

function randomString(length) {
    var result           = '';
    var characters       = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for ( var i = 0; i < length; i++ ) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}

function pullSurveys(user_id) {
	fetch(`${babbleBaseUrl}/get_surveys_for_user_id`, {headers: {'user_id': user_id}})
		.then(resp => resp.json())
		.then(resp_json => {
			window.babbleSurveyData = resp_json.map(obj => {
				const splitName = obj.document.name.split('/')				
				return {
					surveyId: splitName[splitName.length-1],
					triggerId: obj.document.fields.trigger_id.stringValue,
					createdAtUnixTimestamp: new Date(obj.document.fields.created_at.stringValue).getTime(),
					cohortId: obj.document.fields.cohort_id.stringValue,
					samplingPercentage: parseInt(obj.document.fields.sampling_percentage?.integerValue) || parseInt(obj.document.fields.sampling_percentage?.stringValue),
					triggerDelay: parseInt(obj.document.fields?.trigger_delay?.integerValue) || 0

				}
			})
		})
}

function pullTriggers(user_id) {
	fetch(`${babbleBaseUrl}/get_triggers_for_user_id`, {headers: {'user_id': user_id}})
		.then(resp => resp.json())
		.then(resp_json => {
			window.babbleTriggerData = resp_json.map(obj => {
				const splitName = obj.document.name.split('/')				
				return {
					triggerId: splitName[splitName.length-1],
					name: obj.document.fields.name.stringValue
				}
			})
		})
}

function pullQUestions(user_id) {
	fetch(`${babbleBaseUrl}/get_questions_for_user_id`, {headers: {'user_id': user_id}})
		.then(resp => resp.json())
		.then(resp_json => {
			window.babbleQuestionData = resp_json.map(hsh => {
				const doc = hsh.document
				const fields = doc.fields
				return {
					id: doc.name.split("/").slice(-1)[0],
					questionText: fields.question_text.stringValue,
					questionDesc: fields.question_desc.stringValue,
					ctaText: fields?.cta_text?.stringValue || "",
					sequenceNo: parseInt(fields.sequence_no?.stringValue || fields.sequence_no.integerValue),
					surveyId: fields.survey_id.stringValue,
					questionTypeId: parseInt(fields.question_type_id.stringValue || fields.question_type_id.integerValue),
					answers: fields?.answers?.arrayValue?.values?.map(obj => obj.stringValue) || [],
					minValDescr: fields?.min_val_description?.stringValue,
					maxValDescr: fields?.max_val_description?.stringValue,
					skipLogicData: fields?.skip_logic_data?.arrayValue?.values?.map(obj => {
						return {
							nextQuestionId: obj.mapValue.fields.next_question.stringValue,
							respVal: obj.mapValue.fields.resp_val.stringValue
						}
					})
				}
			})
		})
}

function pullEligibleSurveyIds(babbleUserId, customerId) {
	fetch(`${babbleBaseUrl}/eligible_survey_ids`, {
		method: 'POST',
		body: JSON.stringify({babble_user_id: babbleUserId, customer_id: customerId})
	})
	.then(resp => resp.json())
	.then(resp_json => { window.eligibleSurveyIds = resp_json.eligible_survey_ids })
}

function pullCohorts(babbleUserId, customerId) {
	fetch(`${babbleBaseUrl}/get_cohorts`, {
		headers: {'babble_user_id': babbleUserId, 'customer_id': customerId}
	})
	.then(resp => resp.json())
	.then(resp_json => { window.cohorts = resp_json || [] })
}

// function pullBackendEvents(babbleUserId, customerId) {
// 	fetch(`${babbleBaseUrl}/get_backend_events`, {
// 		headers: {'user_id': babbleUserId, 'customer_id': customerId}
// 	})
// 	.then(resp => resp.json())
// 	.then(resp_json => {  cosole.log(resp_json) })
// }

// function babble() {
// 	window._babbleQueue = window._babbleQueue || [];
// 	window._babbleQueue.pushWithEvent(arguments)
// 	const iframe = document.createElement("iframe");
// 	iframe.style.display = "none";
// 	iframe.src = 'https://www.google.com';
// 	iframe.srcdoc = "hello world"
// 	document.body.appendChild(iframe);
// }

function injectBaseElement() {
	var containerDiv = document.createElement('div')
	containerDiv.id = "babbleSection"
	containerDiv.style = "position:fixed;bottom:15px;right:15px;z-index:2147483647;border-radius:5px;box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.2), 0 3px 10px 0 rgba(0, 0, 0, 0.19)"
	document.getElementsByTagName('body')[0].appendChild(containerDiv)
}

Array.prototype.pushWithEvent = function() {
	const argsObj = Array.prototype.slice.call(arguments)[0];
	
	// console.log(argsObj)
	// console.log(Object.keys(argsObj["0"]).length)
	
	if (Object.keys(argsObj).length == 2 && argsObj["0"] == 'init') {
		injectBaseElement()

		var user_id = argsObj["1"]

		window.babbleUserId = user_id
		
		pullSurveys(user_id)
		pullTriggers(user_id)
		pullQUestions(user_id)

	} 

	else if (Object.keys(argsObj["0"]).length == 2) {	
		
		keys = Object.keys(argsObj["0"])
		
		if (keys.length==2 && keys.includes("customerId") && keys.includes("trigger")) {	

			window.customerId = argsObj["0"]["customerId"]

			fetch(`${window.babbleBaseUrl}/eligible_survey_ids`, {
				method: 'POST',
				body: JSON.stringify({babble_user_id: window.babbleUserId, customer_id: window.customerId})
			})
			.then(resp => resp.json())
			.then(resp_json => { 
				window.eligibleSurveyIds = resp_json.eligible_survey_ids

				fetch(`${window.babbleBaseUrl}/get_cohorts`, {
					headers: {'babble_user_id': window.babbleUserId, 'customer_id': window.customerId}
				})
				.then(resp => resp.json())
				.then(resp_json => { 
					window.cohorts = resp_json || []

					window.babbleCurrentIdx = 0

					getData(
						false, 
						{
							triggerName: argsObj["0"]["trigger"], 
							userId: window.babbleUserId,
							timeVal: timeVal(new Date()),
							customerId: window.customerId || 'Anon'+randomString(10)
						}
					)

				})
			})

			// pullEligibleSurveyIds(window.babbleUserId, window.customerId)
			// pullCohorts(window.babbleUserId, window.customerId)

		}
		
	} 

	else if (Object.keys(argsObj["0"]).length==1 && Object.keys(argsObj["0"])[0]=="customerId") {	
		
		window.customerId = argsObj["0"]["customerId"]
		pullEligibleSurveyIds(window.babbleUserId, window.customerId)
		pullCohorts(window.babbleUserId, window.customerId)	
	
	} 

	else if (Object.keys(argsObj["0"]).length==2 && Object.keys(argsObj["0"]).includes("customerId") && Object.keys(argsObj["0"]).includes("properties")) {	
		
		window.customerId = argsObj["0"]["customerId"]
		pullEligibleSurveyIds(window.babbleUserId, window.customerId)
		pullCohorts(window.babbleUserId, window.customerId)

		// console.log("properties accepted: "+JSON.stringify(argsObj["0"]["properties"]))
	
	}
	
	else {
		const trigger = argsObj["0"]
		const customerId = argsObj["1"] || 'Anon'+randomString(10)

		// if (Object.prototype.toString.call(customerId) === '[object Object]') {
		// 	console.log('event props: '+JSON.stringify(customerId))
		// }

		window.babbleCurrentIdx = 0

		getData(
			false, 
			{
				triggerName: trigger, 
				userId: window.babbleUserId,
				timeVal: timeVal(new Date()),
				customerId: window.customerId || customerId
			}
		)
	}
};

function renderBabbleSurvey() {
	const questionData = window.babbleQuestionList[window.babbleCurrentIdx]

	var node;

	switch(questionData.questionTypeId) {
		case 1:
			node = renderChoiceQuestion(
				questionData.questionText, 
				questionData.questionDesc,
				questionData.answers || [],
				'multi'
			); 
			break;
		case 2:
			node = renderChoiceQuestion(
				questionData.questionText, 
				questionData.questionDesc,
				questionData.answers || [],
				'single'
			); 
			break;
	  case 3:
	  	node = renderTextInput(questionData.questionText, questionData.questionDesc); 
	    break;
    case 4:
    	node = renderNumberRating(questionData.questionText, questionData.questionDesc, 10, questionData.minValDescr, questionData.maxValDescr)
    	break;
    case 5:
    	node = renderNumberRating(questionData.questionText, questionData.questionDesc, 5, questionData.minValDescr, questionData.maxValDescr)
    	break;
    case 6:
    	node = renderIntroCard(questionData.questionText, questionData.questionDesc, 'intro')
    	break;
    case 9:
    	node = renderIntroCard(
    		questionData.questionText, 
    		questionData.questionDesc, 
    		'thankYou',
    		{questionTypeId: questionData.questionTypeId}
    	)
    	//Auto-remove thank-you card after 2 seconds
    	setTimeout(() => {
    		document.getElementById('babbleSection').removeChild(document.getElementById('babbleSection').children[0])
    	}, 1500)
    	break;
	  default:
	  	throw "Unsupported question type for Babble survey";
	}
	
	return node;
}

function formattedQuestionData(rawData) {
	return rawData.map(hsh => {
		const fields = hsh.document.fields
		return {
			questionText: fields.question_text.stringValue,
			questionDesc: fields.question_desc.stringValue,
			ctaText: fields?.cta_text?.stringValue || "",
			sequenceNo: parseInt(fields.sequence_no?.stringValue || fields.sequence_no.integerValue),
			surveyId: fields.survey_id.stringValue,
			questionTypeId: parseInt(fields.question_type_id.stringValue || fields.question_type_id.integerValue),
			answers: fields?.answers?.arrayValue?.values.map(obj => obj.stringValue),
			minValDescr: fields?.min_val_description?.stringValue,
			maxValDescr: fields?.max_val_description?.stringValue
		}
	})
}

function renderBabbleSurveyContainer() {
	const containerDiv = document.createElement("div");

	containerDiv.setAttribute("id", 'babbleContainer');

	var widthVal;
	if (navigator.appVersion.indexOf('Win') != -1) {
		 widthVal = "375px"
	} else {
		widthVal = "350px"
	}

	containerDiv.style = "width:"+widthVal+";background-color:white;border-radius:5px;border-style:solid;border-width:1px;border-color:#0937B1";
	return containerDiv
}

function renderQuestionSection(questionText, questionTypeId=null) {
	const baseDiv = document.createElement("div");
	baseDiv.setAttribute("id", 'babbleSurveyQuestion');

	baseDiv.style = "display:grid;grid-template-columns:auto auto"

	const questionTextDiv = document.createElement("div");
	questionTextDiv.style = "margin-top:30px;margin-left:15px;margin-right:15px;font-family:Arial;font-size:18px"
	questionTextDiv.innerHTML = questionText
	
	const cancelDiv = document.createElement("div");
	cancelDiv.style = "margin-top:15px;padding-right:15px;text-align:right"
	cancelDiv.innerHTML = '<svg width="13" height="13" viewBox="0 0 13 13" fill="none" xmlns="http://www.w3.org/2000/svg">\n<path d="M1 12.0002L12.0002 1" stroke="#878585" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>\n<path d="M12.0002 12.0002L1 1" stroke="#878585" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>\n</svg>'

	cancelDiv.addEventListener("click", function(event) {
		document.getElementById('babbleSection').removeChild(document.getElementById('babbleSection').children[0])
		window.babbleCurrentIdx = Number.MAX_SAFE_INTEGER
	})

	// cancelDiv.appendChild(createCancelIcnonSvg())

	baseDiv.appendChild(questionTextDiv)
	baseDiv.appendChild(cancelDiv)

	// if (questionTypeId == 9) {
	// 	div.style = "margin-top:30px;font-family:Arial;font-size:18px;display:flex;justify-content:center;align-items:center";
	// } else {
	// 	div.style = "margin-top:30px;margin-left:15px;margin-right:15px;font-family:Arial;font-size:18px";
	// }
	
	// div.innerHTML = questionText
	return baseDiv
}

function renderDescriptionSection(questionDesc, questionTypeId=null) {
	const div = document.createElement("div");
	div.setAttribute("id", 'babbleSurveyDescription');

	if (questionTypeId == 9) {
		div.style = "font-family:Arial;font-size:14px;color:#ABA7A7;display:flex;justify-content:center;align-items:center"; //margin-top:15px
	} else {
		div.style = "margin-left:15px;margin-right:15px;font-family:Arial;font-size:14px;margin-top:15px;color:#ABA7A7";
	}

	div.innerHTML = questionDesc
	return div
}

function timeVal(dateArg) {
	var curDate = dateArg

	const year = 1900 + curDate.getYear()
	const month = curDate.getMonth() + 1

	var formattedMonth;
	if (month < 10) {
		formattedMonth = "0"+month.toString()
	} else {
		formattedMonth = month
	}

	const day = curDate.getDate() 
	var formattedDay;
	if (day < 10) {
		formattedDay="0"+day.toString()
	} else {
		formattedDay= day
	}
	// const formattedDay = day < 10 ? "0"+day.toString() : day

	var hours;
	if (curDate.getHours() < 10) {
		hours = "0"+curDate.getHours().toString()
	} else {
		hours = curDate.getHours()
	}
	// const hours = curDate.getHours() < 10 ? "0"+curDate.getHours().toString() : curDate.getHours()

	var mins;
	if (curDate.getMinutes() < 10) {
		mins = "0"+curDate.getMinutes().toString()
	} else {
		mins = curDate.getMinutes()
	}
	// const mins = curDate.getMinutes() < 10 ? "0"+curDate.getMinutes().toString() : curDate.getMinutes()

	var secs;
	if (curDate.getSeconds() < 10) {
		secs = "0"+curDate.getSeconds().toString()
	} else {
		secs = curDate.getSeconds()
	}
	// const secs = curDate.getSeconds() < 10 ? "0"+curDate.getSeconds().toString() : curDate.getSeconds()

	const tzOffset = curDate.getTimezoneOffset()

	var tzHours;
	if (tzOffset >= 0) {
		tzHours = Math.floor(tzOffset/60);		
	} else {
		tzHours = Math.abs(Math.ceil(tzOffset/60))
	}

	var formattedTzHours;
	if (tzHours < 10) {
		formattedTzHours="0"+tzHours.toString()
	} else {
		formattedTzHours=tzHours
	}
	// const formattedTzHours = tzHours < 10 ? "0"+tzHours.toString() : tzHours
	
	const tzMins = Math.abs(tzOffset%60)

	var formattedTzMins;
	if (tzMins < 10) {
		formattedTzMins="0"+tzMins.toString()
	} else {
		formattedTzMins=tzMins
	}
	// const formattedTzMins = tzMins < 10 ? "0"+tzMins.toString() : tzMins

	var tzOffsetSign;
	if (tzOffset>0) {
		tzOffsetSign="-"
	} else {
		tzOffsetSign="+"
	}

	return `${year}-${formattedMonth}-${formattedDay}T${hours}:${mins}:${secs}${tzOffsetSign}${formattedTzHours}:${formattedTzMins}`
}

function getResp(lst, questionType, txt) {
	if (lst.length != 0) {
		return lst
	} else {
		if (questionType==1) {
			return []
		} else {
			return txt || document.getElementById("babbleTextArea")?.value || ""
		}
	}	
}

function runSubmitCode(questionType) {
	var lst = [];
	var txt = "";
	const timeValFunc = timeVal

	if (questionType == 1) {
		var lst = [];
		for (let item of document.getElementsByClassName('babbleSelectedAnswer')) {
			lst.push(item.innerHTML)
		}
	} else if (questionType == 2) {
		txt = document.getElementsByClassName("babbleSelectedAnswer")[0]?.innerHTML
	}
	else if (questionType == 4 || questionType == 5) {
		txt = document.getElementsByClassName("babbleSelectedRating")[0]?.innerHTML
	} else if (questionType == 3) {
		txt = document.getElementById("babbleTextArea").value
	}

	const oldIdx = window.babbleCurrentIdx
	const resp = getResp(lst, questionType, txt)
	
	if (window.babbleQuestionList[window.babbleCurrentIdx].skipLogicData?.length || [] > 0) {
		var respForSkipLogic;

		if (Object.prototype.toString.call(resp) === '[object Array]') {
			respForSkipLogic = resp[0]
		} else {
			respForSkipLogic = resp
		}

		var skipLogicOptions = window.babbleQuestionList[window.babbleCurrentIdx].skipLogicData || []

		var relevantSkipLogicOption = skipLogicOptions.find(obj => obj.respVal==respForSkipLogic) || {}
		
		if (Object.keys(relevantSkipLogicOption).length==0) {
			
			var skipLogicOptForAny = skipLogicOptions.find(obj => obj.respVal.toLowerCase()=="any") || {}
			if (Object.keys(skipLogicOptForAny).length==0) {
				window.babbleCurrentIdx = window.babbleCurrentIdx+1
			} else {
				if (skipLogicOptForAny.nextQuestionId.toLowerCase()=="end") {
					window.babbleCurrentIdx = window.babbleQuestionList.length
				} else {
					var newIdx = window.babbleQuestionList.findIndex(obj => obj.id==skipLogicOptForAny.nextQuestionId)
					window.babbleCurrentIdx = newIdx || window.babbleCurrentIdx+1
				}
			}
			
		} else {
			if (relevantSkipLogicOption.nextQuestionId.toLowerCase()=="end") {
				window.babbleCurrentIdx = window.babbleQuestionList.length
			} else {
				var newIdx = window.babbleQuestionList.findIndex(obj => obj.id==relevantSkipLogicOption.nextQuestionId)
				window.babbleCurrentIdx = newIdx || window.babbleCurrentIdx+1
			}
		}
		
	} else {
		window.babbleCurrentIdx = window.babbleCurrentIdx + 1
	}
	
	var nextQuestionTracker;

	const babbleSection = document.getElementById('babbleSection');

	if (window.babbleCurrentIdx < window.babbleQuestionList.length) {
		document.getElementById('babbleSection').removeChild(document.getElementById('babbleSection').children[0])
		document.getElementById('babbleSection').appendChild(renderBabbleSurvey())
		
		if (window.babbleQuestionList[window.babbleQuestionList.length-1].questionTypeId == 9) {			
			if (window.babbleCurrentIdx-1 == window.babbleQuestionList.length-2) {
				nextQuestionTracker = false
			} else {
				nextQuestionTracker = true
			}
		} else {
			
			if (window.babbleCurrentIdx-1 == window.babbleQuestionList.length-1) {			
				nextQuestionTracker = false
			} else {
				nextQuestionTracker = true
			}
		}

	} else {
		document.getElementById('babbleSection').removeChild(document.getElementById('babbleSection').children[0])
		nextQuestionTracker = false
	}


	if (questionType != 6 && questionType != 9) {
		const questionData = window.babbleQuestionList[oldIdx]

		const curDate = new Date()
		const tVal = timeValFunc(curDate)
		
		fetch(
			`${babbleBaseUrl}/write_survery_question_response`, {
			method: 'POST',
			headers: {'babble_user_id': window.babbleUserId},
			body: JSON.stringify({
				survey_id: window.babbleCurrentSurveyId,
				question_type_id: questionData.questionTypeId,
				sequence_no: questionData.sequenceNo,
				response: resp,
				survey_instance_id: window.babbleCurrentSurveyInstanceId,
				question_text: questionData.questionText,
				response_created_at: tVal,
				response_updated_at: tVal,
				next_question_tracker: nextQuestionTracker
			})
		})
	}

}

function renderSubmitSection(questionType) {
	const div1 = document.createElement("div");
	div1.style = "margin-left:15px;width:320px;margin-top:20px;margin-bottom:30px;display:grid;grid-template-columns: 1fr 100px 1fr;"	

	const div2 = document.createElement("div");

	const div3 = document.createElement("div");
	div3.setAttribute("id", 'babbleSubmit');
	div3.style = "height:40px;width:100px;background-color:#0937B1;border-radius:3px;font-family:Arial;color:white;display:flex;align-items:center;justify-content:center;"
	
	var btnTxt = window.babbleQuestionList[window.babbleCurrentIdx]?.ctaText //"Submit";
	div3.innerHTML = btnTxt

	const div4 = document.createElement("div");

	div1.appendChild(div2)
	div2.after(div3)
	div3.after(div4)	
	
	div3.addEventListener("click", function(event) { 		
		runSubmitCode(questionType) 
	})

	return div1
}

function renderNumberRatingSection(numberScale) {
	const parent = document.createElement("div");
	
	if (numberScale == 5) {
		parent.style = "margin-left:15px;width:313px;margin-top:15px;font-family:Arial;display:grid;height:50px;border-radius:3px;border-style:solid;border-width:1px;border-color:#0937B1;grid-template-columns: 1fr 1fr 1fr 1fr 1fr"
	} else if (numberScale == 10) {
		parent.style = "margin-left:15px;width:313px;margin-top:15px;font-family:Arial;display:grid;height:50px;border-radius:3px;border-style:solid;border-width:1px;border-color:#0937B1;grid-template-columns: 1fr 1fr 1fr 1fr 1fr 1fr 1fr 1fr 1fr 1fr"
	}

	for (let i = 1; i <= numberScale; i++) {
		const div = document.createElement("div");
		div.setAttribute("id", "babbleNumberRatingOption"+i.toString())
		
		if (i != numberScale) {
			div.style = "display:flex;align-items:center;justify-content:center;border-right: solid 1px #0937B1;"
		} else {
			div.style = "display:flex;align-items:center;justify-content:center"
		}

		div.innerHTML = i.toString()

		div.addEventListener("mouseover", function(event) {
			if (!event.target.classList.contains('babbleSelectedRating')) {
				event.target.style.backgroundColor = "#0937B1";
				event.target.style.color = "white";
				event.target.style.opacity = 0.5;
			}
		})

		div.addEventListener("mouseout", function(event) {
			if (!event.target.classList.contains('babbleSelectedRating')) {
				div.style.backgroundColor = "white";
				div.style.color = "black";
				div.style.opacity = 1;
			}
		})

		div.addEventListener("click", function(event) {
			if (event.target.classList.contains("babbleSelectedRating")) {

			} else {
				event.target.style.color = "white";
				event.target.style.backgroundColor = "#0937B1";
				event.target.style.opacity = 1;
				event.target.classList.add("babbleSelectedRating");
		
				const list = document.getElementsByClassName('babbleSelectedRating')
				for (let item of list) {
					if (item.id != event.target.id) {
						item.classList.remove("babbleSelectedRating")

						item.style.color = "black";
						item.style.backgroundColor = "white";
					}
				}
			}

			if(numberScale==5) {
				runSubmitCode(5)
			} else {
				runSubmitCode(4)
			}
		})

		parent.appendChild(div)
	}

	return parent
}

function renderTextInput(questionText, questionDesc) {
	const container = renderBabbleSurveyContainer();
	const questionSec = renderQuestionSection(questionText);
	const descriptionSec = renderDescriptionSection(questionDesc);

	container.appendChild(questionSec)
	questionSec.after(descriptionSec)

	const textArea = document.createElement("textArea");
	textArea.setAttribute("id", 'babbleTextArea');
	textArea.style = "margin-left:15px;width:290px;margin-top:15px;height:60px;resize:none;font-family:Arial;padding:10px;font-size:14px;";

	descriptionSec.after(textArea)

	textArea.after(renderSubmitSection(3))

	return container
}

function renderIntroCard(questionText, questionDesc, isIntroOrThankYouCard, opts={}) {
	const container = renderBabbleSurveyContainer();
	var questionSec;
	var descriptionSec;

	if (isIntroOrThankYouCard == 'intro') {
		questionSec = renderQuestionSection(questionText);
		// descriptionSec = renderDescriptionSection(questionDesc);
	} else {
		questionSec = renderQuestionSection(questionText, opts.questionTypeId);
		// descriptionSec = renderDescriptionSection(questionDesc, opts.questionTypeId);
	}

	if (isIntroOrThankYouCard == 'intro') {
		descriptionSec = renderDescriptionSection(questionDesc);
	} else {
		descriptionSec = renderDescriptionSection(questionDesc, opts.questionTypeId);
	}

	container.appendChild(questionSec)
	questionSec.after(descriptionSec)
	
	if (isIntroOrThankYouCard == 'intro') {
		descriptionSec.after(renderSubmitSection(6))
	} else {
		const div = document.createElement("div");
		div.style = "height:25px"//margin-left:15px;width:313px;margin-top:15px;
		descriptionSec.after(div)
	}

	return container
}

function renderAnswerOptions(answerOptions, multiOrSingleSelect) {
	const parent = document.createElement("div");
	parent.style = "margin-left:15px;width:313px;margin-top:15px;"

	for (let i = 0; i < answerOptions.length; i++) { 
		const div1 = document.createElement("div");
		const div2 = document.createElement("div");

		if (i == answerOptions.length-1) {
			div1.style = "width:297.5px;min-height:50px;border: solid 2px #E7E4E4;border-radius:3px;display:flex;align-items:center;padding:5px;padding-left:15px;font-family:Arial;"
		} else {
			div1.style = "width:297.5px;min-height:50px;margin-bottom:10px;border: solid 2px #E7E4E4;border-radius:3px;display:flex;align-items:center;padding:5px;padding-left:15px;font-family:Arial;"
		}

		div1.innerHTML = answerOptions[i]

		parent.appendChild(div1)

		div1.addEventListener("click", function(event) {

			switch(multiOrSingleSelect) {

				case 'single':
					if (!event.target.classList.contains("babbleSelectedAnswer")) {
						// unselect currently selected elements
						const list = document.getElementsByClassName('babbleSelectedAnswer')
						for (let item of list) {
							item.classList.remove("babbleSelectedAnswer")
							item.style.color = "black";
							item.style.backgroundColor = "white";
						}
						
						//select current element
						event.target.classList.add("babbleSelectedAnswer");
						event.target.style.backgroundColor = "#0937B1";
						event.target.style.color = "white";
						event.target.style.opacity = 1;

						runSubmitCode(2)
				}
				break;

				case 'multi':
					if (event.target.classList.contains("babbleSelectedAnswer")) {
						event.target.classList.remove("babbleSelectedAnswer")
						event.target.style.color = "black";
						event.target.style.backgroundColor = "white";
						event.target.style.opacity = 1;
					} else {
						event.target.style.color = "white";
						event.target.style.backgroundColor = "#0937B1";
						event.target.style.opacity = 1;
						event.target.classList.add("babbleSelectedAnswer");
					}
					break;
			}		
		})

		div1.addEventListener("mouseover", function(event) {
			if (!event.target.classList.contains('babbleSelectedAnswer')) {
				event.target.style.backgroundColor = "#0937B1";
				event.target.style.color = "white";
				event.target.style.opacity = 0.5;
			}
		})

		div1.addEventListener("mouseout", function(event) {
			if (!event.target.classList.contains('babbleSelectedAnswer')) {
				event.target.style.backgroundColor = "white";
				event.target.style.color = "black";
				event.target.style.opacity = 1;
			}
		})
	}

	return parent
}

function renderNumberRating(questionText, questionDesc, numberScale, min_val_descr, max_val_descr) {
	const container = renderBabbleSurveyContainer();
	const questionSec = renderQuestionSection(questionText);
	const descriptionSec = renderDescriptionSection(questionDesc);

	container.appendChild(questionSec)
	questionSec.after(descriptionSec)

	const ratingSection = renderNumberRatingSection(numberScale)

	const sec = document.createElement("div");
	sec.style = "display:grid;grid-template-columns: 1fr 1fr 1fr;margin-left:15px;width:313px;font-family:Arial;font-size:15px;margin-top:7.5px;color:#ABA7A7"

	col1 = document.createElement("div")
	col1.style = "word-wrap:break-word"
	col1.innerHTML = min_val_descr
	
	col2 = document.createElement("div");
	
	col3 = document.createElement("div");
	col3.style = "text-align:right;word-wrap:break-word"
	col3.innerHTML = max_val_descr

	sec.appendChild(col1)
	sec.appendChild(col2)
	sec.appendChild(col3)

	descriptionSec.after(ratingSection)
	ratingSection.after(sec)
	// sec.after(renderSubmitSection(window.babbleQuestionList[babbleCurrentIdx].questionTypeId))
	const spaceDiv = document.createElement("div");
	spaceDiv.style.height = "30px"
	sec.after(spaceDiv)

	return container
}

function renderChoiceQuestion(questionText, questionDesc, answerOptions, multiOrSingleSelect) {
	const container = renderBabbleSurveyContainer();
	container.style.borderColor = "#0937B1"
	container.style.maxHeight = "500px"
	if (answerOptions.length > 5) {
		container.style.overflowY = "scroll"
	}

	const questionSec = renderQuestionSection(questionText);
	const descriptionSec = renderDescriptionSection(questionDesc);

	container.appendChild(questionSec)
	questionSec.after(descriptionSec)

	const ansOptsSec = renderAnswerOptions(answerOptions, multiOrSingleSelect)
	descriptionSec.after(ansOptsSec)

	if (multiOrSingleSelect=="multi") {
		const data1 = window.babbleQuestionList[babbleCurrentIdx].questionTypeId
		ansOptsSec.after(renderSubmitSection(data1))
	} else {
		const spaceDiv = document.createElement("div");
		spaceDiv.style.height = "30px"
		ansOptsSec.after(spaceDiv)
	}

	return container
}

function getData(stubbedData=true, data={})  {
	if (stubbedData) {
		window.rawQuestionList = [ 
			//{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/Vaws9iPkhS4NLZlJjpfM", "fields": { "question_type_id": { "integerValue": "7" }, "inactive": { "booleanValue": false }, "question_desc": { "stringValue": "This will help us service you better" }, "template_id": { "stringValue": "" }, "cta_text": { "stringValue": "Next" }, "max_val_description": { "stringValue": "" }, "min_val_description": { "stringValue": "" }, "sequence_no": { "integerValue": "7" }, "question_text": { "stringValue": "Please rate your experience" }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "is_default": { "booleanValue": true } }, "createTime": "2022-12-02T11:55:33.929253Z", "updateTime": "2022-12-02T11:55:33.929253Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/3xh4WNU7TdvoL3PGxKdV", "fields": { "sequence_no": { "integerValue": "4" }, "question_type_id": { "integerValue": "4" }, "cta_text": { "stringValue": "Next" }, "template_id": { "stringValue": "" }, "is_default": { "booleanValue": true }, "max_val_description": { "stringValue": "Very likely" }, "question_text": { "stringValue": "How likely are you recommend our product to a friend?" }, "inactive": { "booleanValue": false }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "min_val_description": { "stringValue": "Very unlikely" }, "question_desc": { "stringValue": "This will help us service you better" } }, "createTime": "2022-12-02T11:48:05.933912Z", "updateTime": "2022-12-02T11:48:05.933912Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/WmTlNCw3iCjTa3j8OFiB", "fields": { "template_id": { "stringValue": "" }, "question_type_id": { "integerValue": "2" }, "inactive": { "booleanValue": false }, "sequence_no": { "integerValue": "2" }, "is_default": { "booleanValue": true }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "cta_text": { "stringValue": "Next" }, "question_text": { "stringValue": "Where did you find out about us?" }, "question_desc": { "stringValue": "This will help us serve you better" }, "answers": { "arrayValue": { "values": [ { "stringValue": "Google" }, { "stringValue": "Facebook" }, { "stringValue": "Twitter" }, { "stringValue": "Other" } ] } } }, "createTime": "2022-12-02T11:43:31.451664Z", "updateTime": "2022-12-02T11:43:31.451664Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			//{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/dqGdvwZfjx0SIkeCw7tR", "fields": { "template_id": { "stringValue": "" }, "question_text": { "stringValue": "Please rate your experience" }, "sequence_no": { "integerValue": "8" }, "question_desc": { "stringValue": "This will help us service you better" }, "question_type_id": { "integerValue": "8" }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "cta_text": { "stringValue": "Next" }, "inactive": { "booleanValue": false }, "max_val_description": { "stringValue": "" }, "min_val_description": { "stringValue": "" }, "is_default": { "booleanValue": true } }, "createTime": "2022-12-02T11:58:21.564365Z", "updateTime": "2022-12-02T11:58:21.564365Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/ewU5BWa6LhXh4WI1GbR6", "fields": { "cta_text": { "stringValue": "Next" }, "question_type_id": { "integerValue": "6" }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "question_text": { "stringValue": "Can you take a quick survey" }, "template_id": { "stringValue": "" }, "inactive": { "booleanValue": false }, "sequence_no": { "integerValue": "6" }, "question_desc": { "stringValue": "This will help us service you better" }, "is_default": { "booleanValue": true } }, "createTime": "2022-12-02T11:52:52.584762Z", "updateTime": "2022-12-02T11:52:52.584762Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/fx8XvIEfb38QzMrluUak", "fields": { "question_desc": { "stringValue": "" }, "template_id": { "stringValue": "" }, "cta_text": { "stringValue": "Submit" }, "is_deafult": { "booleanValue": true }, "sequence_no": { "integerValue": "3" }, "question_type_id": { "integerValue": "3" }, "question_text": { "stringValue": "Any additional feedback?" }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "inactive": { "booleanValue": false } }, "createTime": "2022-12-02T11:45:50.463279Z", "updateTime": "2022-12-02T11:45:50.463279Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/gp4gglf87hhtepr3nR7T", "fields": { "template_id": { "stringValue": "" }, "question_desc": { "stringValue": "This will help us service you better" }, "min_val_description": { "stringValue": "Very dissatisfied" }, "cta_text": { "stringValue": "Next" }, "question_type_id": { "integerValue": "5" }, "is_default": { "booleanValue": true }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "max_val_description": { "stringValue": "Very satisfied" }, "sequence_no": { "integerValue": "5" }, "question_text": { "stringValue": "What is your overall satisfaction with [this feature]?" }, "inactive": { "booleanValue": false } }, "createTime": "2022-12-02T11:50:19.031214Z", "updateTime": "2022-12-02T11:50:19.031214Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/yXVCgeQCq1o4pGbHxNiY", "fields": { "sequence_no": { "integerValue": "9" }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" }, "is_default": { "booleanValue": true }, "inactive": { "booleanValue": false }, "question_desc": { "stringValue": "Thanks for sharing your feedback" }, "question_type_id": { "integerValue": "1" }, "question_text": { "stringValue": "" }, "template_id": { "stringValue": "" } }, "createTime": "2022-12-02T12:00:03.267920Z", "updateTime": "2022-12-02T12:00:03.267920Z" }, "readTime": "2022-12-04T23:47:35.614600Z" }, 
			{ "document": { "name": "projects/babble-v1/databases/(default)/documents/questions/zyMGVhjpMvsSsaxWdwGu", "fields": { "is_default": { "booleanValue": true }, "sequence_no": { "integerValue": "1" }, "answers": { "arrayValue": { "values": [ { "stringValue": "Feature 1" }, { "stringValue": "Feature 2" }, { "stringValue": "Feature 3" }, { "stringValue": "Feature 4" }, { "stringValue": "Feature 5" } ] } }, "question_type_id": { "integerValue": "1" }, "inactive": { "booleanValue": false }, "template_id": { "stringValue": "" }, "question_desc": { "stringValue": "This will help us meet your expectations better" }, "cta_text": { "stringValue": "Next" }, "question_text": { "stringValue": "Select the feature/s that you most want" }, "survey_id": { "stringValue": "fJNl7PSixmAwgtFoTsCS" } }, "createTime": "2022-12-02T11:40:51.210106Z", "updateTime": "2022-12-02T11:40:51.210106Z" }, "readTime": "2022-12-04T23:47:35.614600Z" } 
		]

		var formattedQuestions = formattedQuestionData(rawQuestionList);
		window.babbleQuestionList = formattedQuestions.sort((a,b) => a.sequenceNo - b.sequenceNo)
		
		document.getElementById("babbleSection").appendChild(renderBabbleSurvey())
	} else {		

		window.babbleTriggerId = (window.babbleTriggerData || []).filter(obj => obj.name == data.triggerName)[0].triggerId
		const randomSamplingNum = randomIntFromInterval(0, 100)
		var triggerDelay = 0;
		
		window.babbleCurrentSurveyId = (window.babbleSurveyData || []).filter(obj => {
			var filterResult = (obj.triggerId == window.babbleTriggerId) && 
				window.eligibleSurveyIds.includes(obj.surveyId) &&
				(!obj.cohortId || (obj.cohortId && window.cohorts.length > 0)) && 
				(obj.samplingPercentage && randomSamplingNum < obj.samplingPercentage)

			if (filterResult && obj.triggerDelay && obj.triggerDelay > 0) {
				console.log(obj.triggerDelay)
				triggerDelay = obj.triggerDelay
			}
			
			return filterResult
		}).sort((a,b) => b.createdAtUnixTimestamp - a.createdAtUnixTimestamp)[0]?.surveyId
		
		window.babbleCurrentSurveyInstanceId = randomString(10)

		if (window.babbleCurrentSurveyId) {
			fetch(`${babbleBaseUrl}/create_survey_instance`, {
				method: "POST",
				body: JSON.stringify({
					survey_id: window.babbleCurrentSurveyId,
					user_id: window.babbleUserId,
					time_val: data.timeVal,
					customer_id: data.customerId,
					survey_instance_id: babbleCurrentSurveyInstanceId,
				})
			})
			
			var formattedQuestions = window.babbleQuestionData.filter(obj => obj.surveyId == babbleCurrentSurveyId)
			window.babbleQuestionList = formattedQuestions.sort((a,b) => a.sequenceNo - b.sequenceNo)
			
			setTimeout(() => {
				document.getElementById("babbleSection").appendChild(renderBabbleSurvey())
    		}, triggerDelay*1000)

		}

	}
}